Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 1438089

Summary: Review Request: golang-github-xtaci-kcp-go - Production-Grade Reliable-UDP Library for golang
Product: [Fedora] Fedora Reporter: Fabio Valentini <decathorpe>
Component: Package ReviewAssignee: Athos Ribeiro <athoscribeiro>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: athoscribeiro, package-review, tcallawa
Target Milestone: ---Flags: athoscribeiro: fedora-review+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2017-05-19 19:03:55 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On: 1437471    
Bug Blocks: 1427634    

Description Fabio Valentini 2017-03-31 21:22:59 UTC
Spec URL: https://decathorpe.fedorapeople.org/packages/golang-github-xtaci-kcp-go.spec

SRPM URL: https://decathorpe.fedorapeople.org/packages/golang-github-xtaci-kcp-go-3.13-1.fc25.src.rpm

Description: Production-Grade Reliable-UDP Library for golang

Fedora Account System Username: decathorpe


I can't provide a koji scratch build yet, since some dependencies are not yet available on fedora (marked as blocker bugs). With local builds (present dependencies) I had to disable tests, since they hit "too many open files" errors in mock chroots, where I can't set "ulimit -n 102400" - or something like that.

This go package is one of the new dependencies of syncthing 0.14.25.

Comment 1 Fabio Valentini 2017-05-04 21:40:29 UTC
I've updated the packaging for the latest stable version of the golang package.

Spec URL: https://decathorpe.fedorapeople.org/packages/golang-github-xtaci-kcp-go.spec

SRPM URL: https://decathorpe.fedorapeople.org/packages/golang-github-xtaci-kcp-go-3.15-1.fc26.src.rpm

Additionally, I've reported the test failures upstream, maybe they can be resolved: https://github.com/xtaci/kcp-go/issues/40

Comment 2 Fabio Valentini 2017-05-11 21:20:13 UTC
The failing test needs more than 1024 open sockets to succeed, which results in more open files than fedora's default setting (1024) allows. As a result, I have disabled that test with a patch.

Comment 3 Athos Ribeiro 2017-05-15 14:03:52 UTC
Hi Fabio,

The package looks good!

Before approving it, do you have any comments on the images provided by upstream? In special, shannon.jpg. I did not find a license tag nor the original file.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[?]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     github-xtaci-kcp-go-devel , golang-github-xtaci-kcp-go-unit-test-devel
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: golang-github-xtaci-kcp-go-devel-3.15-1.fc27.noarch.rpm
          golang-github-xtaci-kcp-go-unit-test-devel-3.15-1.fc27.x86_64.rpm
          golang-github-xtaci-kcp-go-3.15-1.fc27.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
golang-github-xtaci-kcp-go-devel (rpmlib, GLIBC filtered):
    golang(github.com/klauspost/reedsolomon)
    golang(github.com/pkg/errors)
    golang(golang.org/x/crypto/blowfish)
    golang(golang.org/x/crypto/cast5)
    golang(golang.org/x/crypto/pbkdf2)
    golang(golang.org/x/crypto/salsa20)
    golang(golang.org/x/crypto/tea)
    golang(golang.org/x/crypto/twofish)
    golang(golang.org/x/crypto/xtea)
    golang(golang.org/x/net/ipv4)

golang-github-xtaci-kcp-go-unit-test-devel (rpmlib, GLIBC filtered):
    golang-github-xtaci-kcp-go-devel



Provides
--------
golang-github-xtaci-kcp-go-devel:
    golang(github.com/xtaci/kcp-go)
    golang-github-xtaci-kcp-go-devel

golang-github-xtaci-kcp-go-unit-test-devel:
    golang-github-xtaci-kcp-go-unit-test-devel
    golang-github-xtaci-kcp-go-unit-test-devel(x86-64)



Source checksums
----------------
https://github.com/xtaci/kcp-go/archive/e820b1bd15f3e98fabd014eab5585b5cf55db4f1/xtaci-kcp-go-e820b1b.tar.gz :
  CHECKSUM(SHA256) this package     : 07e4d14459b2888ef6e579ce3f019a0abac56b2e21ff26e8ee75f302d31071a5
  CHECKSUM(SHA256) upstream package : 07e4d14459b2888ef6e579ce3f019a0abac56b2e21ff26e8ee75f302d31071a5

Comment 4 Fabio Valentini 2017-05-15 20:50:58 UTC
All pictures are only referenced and used by the README.md file. They aren't part of the produced binary RPMs, only of the upstream source tarball.

I found the original image source (Photo by Alfred Eisenstaedt/The LIFE Picture Collection/Getty Images), and the picture was taken in 1963.

I'm not sure how to proceed here, since the pictures aren't used by my packaging at all - do I have to produce a "special" tarball that differs from upstream's sources, just because of a file that I don't use anyway?

Blocking FE-Legal to get a definitive answer (because I'd rather not create a downstream tarball for no good reason).

Comment 5 Tom "spot" Callaway 2017-05-16 16:10:10 UTC
Yeah, Getty Images does not mess around with licensing. You need to remove this image from the source tarball and use a "clean" tarball. I'd also strongly recommend that you open an issue with upstream to ask them to remove that jpg.

Comment 6 Fabio Valentini 2017-05-16 19:23:22 UTC
Tom, thanks for looking into this!

I just informed upstream that they might want to stop using/distributing the picture [1].

If this can be resolved upstream soon-ish, I'll update the upstream tarball to a snapshot not containing the picture. If not, I'll write a script for generating a "clean" tarball.

[1]: https://github.com/xtaci/kcp-go/issues/42

Comment 7 Fabio Valentini 2017-05-17 09:03:10 UTC
Upstream has removed the picture in question, unblocking FE-Legal.

Spec URL: https://decathorpe.fedorapeople.org/packages/golang-github-xtaci-kcp-go.spec

SRPM URL: https://decathorpe.fedorapeople.org/packages/golang-github-xtaci-kcp-go-3.15-1.20170517.git2fd1e3d.fc26.src.rpm

Comment 8 Athos Ribeiro 2017-05-17 10:57:31 UTC
Package looks good now.

Approved

Comment 9 Fabio Valentini 2017-05-17 12:37:07 UTC
Thank you for the review!

Comment 10 Gwyn Ciesla 2017-05-17 13:19:00 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/golang-github-xtaci-kcp-go

Comment 11 Fedora Update System 2017-05-17 14:57:29 UTC
golang-github-xtaci-kcp-go-3.15-1.20170517.git2fd1e3d.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-bbbfd7ca0f

Comment 12 Fedora Update System 2017-05-17 14:58:07 UTC
golang-github-xtaci-kcp-go-3.15-1.20170517.git2fd1e3d.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-55a467330b

Comment 13 Fedora Update System 2017-05-17 14:58:43 UTC
golang-github-xtaci-kcp-go-3.15-1.20170517.git2fd1e3d.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-2141376bf0

Comment 14 Fedora Update System 2017-05-18 19:03:52 UTC
golang-github-xtaci-kcp-go-3.15-1.20170517.git2fd1e3d.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-bbbfd7ca0f

Comment 15 Fedora Update System 2017-05-18 23:30:33 UTC
golang-github-xtaci-kcp-go-3.15-1.20170517.git2fd1e3d.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-2141376bf0

Comment 16 Fedora Update System 2017-05-18 23:35:14 UTC
golang-github-xtaci-kcp-go-3.15-1.20170517.git2fd1e3d.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-55a467330b

Comment 17 Fedora Update System 2017-05-27 02:52:09 UTC
golang-github-xtaci-kcp-go-3.15-1.20170517.git2fd1e3d.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2017-05-27 03:01:01 UTC
golang-github-xtaci-kcp-go-3.15-1.20170517.git2fd1e3d.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2017-06-09 19:00:41 UTC
golang-github-xtaci-kcp-go-3.15-1.20170517.git2fd1e3d.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.